<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2007
sirfragalot@users.sourceforge.net
**********************************************************************************/
/*****
*	Email class.
*****/
class EMAIL
{
// Constructor
	function EMAIL($db, $vars = FALSE)
	{
		$this->db = $db;
		$this->vars = $vars;
		include_once("core/template/TEMPLATE.php");
		$this->template = new TEMPLATE('content');
		include_once("core/messages/ERRORS.php");
		$this->errors = new ERRORS();
		include_once("core/messages/MESSAGES.php");
		$this->messages = new MESSAGES();
		include_once("core/messages/SUCCESS.php");
		$this->success = new SUCCESS();
		include_once("core/html/MISC.php");
		include_once("core/html/FORM.php");
		include_once("core/session/SESSION.php");
		$this->session = new SESSION();
	}
// Display form in pop-up for emailing a link to a friend
	function emailFriendDisplay($error = FALSE)
	{
		include_once("core/html/CLOSEPOPUP.php");
		if(array_key_exists('id', $this->vars))
		{
			global $_SERVER;
			$hyperlink = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['SCRIPT_NAME'] . "?action=resourceView&id=" . $this->vars['id'];
		}
		$this->template->setVar('heading', $this->messages->text("heading", "emailFriend"));
		$error ? $pString = $error : $pString = '';
		$this->template->setVar('formStart', FORM::formHeader("emailFriend"));
		$address = $this->session->getVar("emailFriend_address");
		$subject = $this->session->getVar("emailFriend_subject");
		if(isset($hyperlink))
			$text = "\n\n$hyperlink";
		else
		{
			$text = $this->session->getVar("emailFriend_text");
		}
		$pString .= MISC::p(FORM::textInput($this->messages->text("misc", "emailFriendAddress"), 
			"emailFriend_address", $address, 40));
		$pString .= MISC::p(FORM::textInput($this->messages->text("misc", "emailFriendSubject"), 
			"emailFriend_subject", $subject, 80));
		$pString .= MISC::p(FORM::textareaInput($this->messages->text("misc", "emailFriendText"), 
			"emailFriend_text", $text, 80, 10));
		$pString .= MISC::p(FORM::formSubmit("email"), FALSE, 'right');
		$this->template->setVar('body', $pString);
		$this->template->setVar('formEnd', FORM::formEnd());
		new CLOSEPOPUP($this->template->process());
	}
// Send email
	function emailFriend()
	{
		list($address, $subject, $text) = $this->checkInput();
		include_once("core/html/CLOSEPOPUP.php");
		$this->template->setVar('heading', $this->messages->text("heading", "emailFriend"));
		$headers = "From: WIKINDX\n";
		$headers .= "Reply-to: noReply\r\n";
		@mail($address, $subject, $text, $headers); // don't check for mail server failure
		$this->session->clearArray('emailFriend');
		$this->template->setVar('body', $this->success->text('emailFriend'));
		new CLOSEPOPUP($this->template->process());
	}
	function checkInput()
	{
		$address = $subject = $text = FALSE;
		if(array_key_exists('emailFriend_address', $this->vars))
			$address = trim($this->vars['emailFriend_address']);
		if(array_key_exists('emailFriend_subject', $this->vars))
			$subject = trim($this->vars['emailFriend_subject']);
		if(array_key_exists('emailFriend_text', $this->vars))
			$text = trim($this->vars['emailFriend_text']);
		$this->session->setVar('emailFriend_address', $address);
		$this->session->setVar('emailFriend_subject', $subject);
		$this->session->setVar('emailFriend_text', $text);
		if(!$address || !$subject || !$text)
			$this->badInput('emailFriendDisplay', $this->errors->text('inputError', 'missing'));
		return array($address, $subject, $text);
	}
// Error handling
	function badInput($function, $error)
	{
		include_once("core/html/CLOSEPOPUP.php");
		new CLOSEPOPUP($this->$function($error));
	}
}
?>